/////////////////////////////////////////////////////////////////////////////
//
// wxWebServer - a simple web server using wxWidgets framework
//
// File:        aboutdialog.cpp
// 
// Author:      Fedja Stevanovic
// 
// Copyright:   Copyright (C) 2007 Fedja Stevanovic (tutubibi.net)
//
// Licence:
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////////////

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma implementation "aboutdialog.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "aboutdialog.h"

////@begin XPM images
////@end XPM images


/*!
 * AboutDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( AboutDialog, wxDialog )


/*!
 * AboutDialog event table definition
 */

BEGIN_EVENT_TABLE( AboutDialog, wxDialog )

////@begin AboutDialog event table entries
    EVT_BUTTON( ID_BUTTON_CLOSE_ABOUT, AboutDialog::OnButtonCloseAboutClick )

////@end AboutDialog event table entries

END_EVENT_TABLE()


/*!
 * AboutDialog constructors
 */

AboutDialog::AboutDialog()
{
    Init();
}

AboutDialog::AboutDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * AboutDialog creator
 */

bool AboutDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin AboutDialog creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end AboutDialog creation
    return true;
}


/*!
 * AboutDialog destructor
 */

AboutDialog::~AboutDialog()
{
////@begin AboutDialog destruction
////@end AboutDialog destruction
}


/*!
 * Member initialisation
 */

void AboutDialog::Init()
{
////@begin AboutDialog member initialisation
////@end AboutDialog member initialisation
}


/*!
 * Control creation for AboutDialog
 */

void AboutDialog::CreateControls()
{    
////@begin AboutDialog content construction
    AboutDialog* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxStaticText* itemStaticText3 = new wxStaticText( itemDialog1, wxID_STATIC, _("wxWebServer"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText3->SetForegroundColour(wxColour(0, 64, 128));
    itemStaticText3->SetFont(wxFont(12, wxSWISS, wxNORMAL, wxBOLD, false, wxT("Tahoma")));
    itemBoxSizer2->Add(itemStaticText3, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 10);

    wxStaticText* itemStaticText4 = new wxStaticText( itemDialog1, wxID_STATIC, _("Version 1.0.1 (2007-07-13)"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStaticText4->SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL, false, wxT("Lucida Grande")));
    itemBoxSizer2->Add(itemStaticText4, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxStaticText* itemStaticText5 = new wxStaticText( itemDialog1, wxID_STATIC, _("A very simple web server written using wxWidgets Framework. Licensed under GPL v3. Visit http://www.gnu.org/copyleft/gpl.html for more information about the licence.\n\nIcons by Laurent Baumann (http://lbaumann.com).\n\nMore information and the latest source code for this application is available online at www.senkas.com."), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT );
    itemStaticText5->Wrap(340);
    itemBoxSizer2->Add(itemStaticText5, 0, wxGROW|wxALL, 10);

    wxHyperlinkCtrl* itemHyperlinkCtrl6 = new wxHyperlinkCtrl( itemDialog1, ID_HYPERLINKCTRL1, _("SENKAS.COM"), _T("http://www.senkas.com"), wxDefaultPosition, wxDefaultSize, wxHL_DEFAULT_STYLE );
    itemBoxSizer2->Add(itemHyperlinkCtrl6, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 20);

    wxButton* itemButton7 = new wxButton( itemDialog1, ID_BUTTON_CLOSE_ABOUT, _("Close"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(itemButton7, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 10);

////@end AboutDialog content construction
}


/*!
 * Should we show tooltips?
 */

bool AboutDialog::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap AboutDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin AboutDialog bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end AboutDialog bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon AboutDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin AboutDialog icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end AboutDialog icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CLOSE_ABOUT
 */

void AboutDialog::OnButtonCloseAboutClick( wxCommandEvent& event )
{
////@begin wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CLOSE_ABOUT in AboutDialog.
    // Before editing this code, remove the block markers.
    EndModal(ID_BUTTON_CLOSE_ABOUT);
////@end wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CLOSE_ABOUT in AboutDialog. 
}

