/////////////////////////////////////////////////////////////////////////////
//
// wxWebServer - a simple web server using wxWidgets framework
//
// File:        contenttypes.h
// 
// Author:      Fedja Stevanovic
// 
// Copyright:   Copyright (C) 2007 Fedja Stevanovic (tutubibi.net)
//
// Licence:
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _CONTENTTYPES_H_
#define _CONTENTTYPES_H_

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma interface "contenttypes.h"
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

// hash map for content types
WX_DECLARE_STRING_HASH_MAP( wxString, ContentTypesHash );

class ContentTypes
{

private:
    static bool exists;
    static ContentTypes* instance;
    ContentTypes( );

	ContentTypesHash contentTypes;

public:
    static ContentTypes* getInstance();
    wxString getContentType( const wxString& fileExt );
	wxString getFallbackContentType();
    virtual ~ContentTypes();

};

#endif
// _CONTENTTYPES_H_

