/////////////////////////////////////////////////////////////////////////////
//
// wxWebServer - a simple web server using wxWidgets framework
//
// File:        wxwebserver.cpp
// 
// Author:      Fedja Stevanovic
// 
// Copyright:   Copyright (C) 2007 Fedja Stevanovic (tutubibi.net)
//
// Licence:
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////////////

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma implementation "wxwebserver.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "wxwebserver.h"

////@begin XPM images
////@end XPM images


/*!
 * Application instance implementation
 */

////@begin implement app
IMPLEMENT_APP( WxWebServerApp )
////@end implement app


/*!
 * WxWebServerApp type definition
 */

IMPLEMENT_CLASS( WxWebServerApp, wxApp )


/*!
 * WxWebServerApp event table definition
 */

BEGIN_EVENT_TABLE( WxWebServerApp, wxApp )

////@begin WxWebServerApp event table entries
////@end WxWebServerApp event table entries

END_EVENT_TABLE()


/*!
 * Constructor for WxWebServerApp
 */

WxWebServerApp::WxWebServerApp()
{
    Init();
}


/*!
 * Member initialisation
 */

void WxWebServerApp::Init()
{
////@begin WxWebServerApp member initialisation
////@end WxWebServerApp member initialisation
}

/*!
 * Initialisation for WxWebServerApp
 */

bool WxWebServerApp::OnInit()
{    
////@begin WxWebServerApp initialisation
	// Remove the comment markers above and below this block
	// to make permanent changes to the code.

#if wxUSE_XPM
	wxImage::AddHandler(new wxXPMHandler);
#endif
#if wxUSE_LIBPNG
	wxImage::AddHandler(new wxPNGHandler);
#endif
#if wxUSE_LIBJPEG
	wxImage::AddHandler(new wxJPEGHandler);
#endif
#if wxUSE_GIF
	wxImage::AddHandler(new wxGIFHandler);
#endif
	WebServerMain* mainWindow = new WebServerMain(NULL, ID_WXWEBSERVER, _("wxWebServer"));
	/* int returnValue = */ mainWindow->ShowModal();

	mainWindow->Destroy();
	// A modal dialog application should return false to terminate the app.
	return false;
////@end WxWebServerApp initialisation

    return true;
}


/*!
 * Cleanup for WxWebServerApp
 */

int WxWebServerApp::OnExit()
{    
////@begin WxWebServerApp cleanup
	return wxApp::OnExit();
////@end WxWebServerApp cleanup
}

